﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using GrapeCity.ActiveReports;

namespace Dynamic_PageSize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        SectionReport1 rpt;
        private void Form1_Load(object sender, EventArgs e)
        {
            // 报表数据源
            string connectionstring = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=Data\\NWind_CHS.mdb;Persist Security Info=False";
            string commandstring = "select top 43 * from 产品";

            DataTable dt = new DataTable();

            using (OleDbConnection connection = new OleDbConnection(connectionstring))
            {
                OleDbDataAdapter adapter = new OleDbDataAdapter(commandstring, connection);
                adapter.Fill(dt);
            }

            // 生成报表
            rpt = new SectionReport1();
            rpt.DataSource = dt;
            rpt.Run();

            // 加载报表到窗体中
            viewer1.Document = rpt.Document;
        }

        private void 连续打印ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // 连续打印报表
            GrapeCity.ActiveReports.Document.Section.Page aPage = new GrapeCity.ActiveReports.Document.Section.Page();
            aPage.Width = rpt.PageSettings.PaperWidth;
            aPage.Height = rpt.PageSettings.PaperHeight;

            // 创建SystemPrinter对象
            GrapeCity.ActiveReports.SystemPrinter m_myARPrinter = new GrapeCity.ActiveReports.SystemPrinter();
            m_myARPrinter.PrintDialog();
            m_myARPrinter.PaperSize = new System.Drawing.Printing.PaperSize("Custom Size", Convert.ToInt32(aPage.Width * 100), Convert.ToInt32(aPage.Height * 100));

            // 启动打印任务
            m_myARPrinter.StartJob("连续打印");
            System.Drawing.RectangleF rec;

            // 打印出最后一页之外的所有页
            int nCount = rpt.Document.Pages.Count;
            for (int i = 0; i < nCount - 1; i++)
            {
                m_myARPrinter.StartPage();
                m_myARPrinter.Graphics.PageUnit = GraphicsUnit.Pixel;

                aPage = rpt.Document.Pages[i];
                m_myARPrinter.PaperSize = new System.Drawing.Printing.PaperSize("Custom Size", Convert.ToInt32(aPage.Width * 100), Convert.ToInt32(aPage.Height * 100));

                rec = new RectangleF(0, 0, aPage.Width, aPage.Height);

                aPage.Draw(m_myARPrinter.Graphics, rec, 1f, 1f);
                m_myARPrinter.EndPage();
            }
            m_myARPrinter.EndJob();

            // 打印最后一页，此时需要重新设置打印机纸张大小
            aPage = rpt.Document.Pages[nCount - 1];
            m_myARPrinter.PaperSize = new System.Drawing.Printing.PaperSize("Custom Size", Convert.ToInt32(aPage.Width * 100), Convert.ToInt32(aPage.Height * 100));

            m_myARPrinter.StartJob("连续打印");
            m_myARPrinter.StartPage();
            m_myARPrinter.Graphics.PageUnit = GraphicsUnit.Pixel;

            rec = new RectangleF(0, 0, aPage.Width, aPage.Height);

            aPage.Draw(m_myARPrinter.Graphics, rec, 1f, 1f);
            m_myARPrinter.EndPage();
            m_myARPrinter.EndJob();
        }
    }
}
